﻿Imports System.Runtime.InteropServices

Public Class Form1

    Private Sub Button1_Click(sender As System.Object, e As System.EventArgs) Handles Button1.Click
        Dim open_stat As Integer
        Dim dll_ver As UShort
        Dim firm_ver As UShort
        Dim maj As UShort
        Dim min As UShort
        Dim rev As UShort
        Dim ver As String

        ' DLL version acquisition 
        dll_ver = UPT_GetDllVer()
        maj = (dll_ver >> 8) And &HFF
        min = (dll_ver >> 4) And &HF
        rev = dll_ver And &HF
        ver = "DLL ver : " + maj.ToString + "." + min.ToString + "." + rev.ToString
        MsgBox(ver)

        ' Connect 
        open_stat = UPT_Open()
        If open_stat = 0 Then
            UPT_Reset()

            ' Firmware version acquisition 
            firm_ver = UPT_GetFirmVer()
            maj = (firm_ver >> 8) And &HFF
            min = (firm_ver >> 4) And &HF
            rev = firm_ver And &HF
            ver = "Firm ver : " + maj.ToString + "." + min.ToString + "." + rev.ToString
            MsgBox(ver)

            ' Firmware version display 
            'TextBox1.Text = dll_str + firm_str

            'RED・White ON + Buzzer 
            UPT_SetTower(ON_STATIC, OFF_STATIC, OFF_STATIC, OFF_STATIC, ON_STATIC)
            UPT_SetBuzEx(ON_STATIC, 0, BUZ_PITCH1, BUZ_PITCH_DFLT)
            System.Threading.Thread.Sleep(700)
            UPT_Reset()
            System.Threading.Thread.Sleep(300)

            ' Yellow・Blue　ON＋Buzzer 
            UPT_SetTower(OFF_STATIC, ON_STATIC, OFF_STATIC, ON_STATIC, OFF_STATIC)
            UPT_SetBuzEx(ON_STATIC, 0, BUZ_PITCH1, BUZ_PITCH_DFLT)
            System.Threading.Thread.Sleep(700)
            UPT_Reset()
            System.Threading.Thread.Sleep(300)

            ' Green　ON＋Buzzer 
            UPT_SetTower(OFF_STATIC, OFF_STATIC, ON_STATIC, OFF_STATIC, OFF_STATIC)
            UPT_SetBuzEx(ON_STATIC, 1, BUZ_PITCH13, BUZ_PITCH_DFLT)

            UPT_Close() ' connection finished 
        Else
            MsgBox("Failure to UPT_Open")

        End If
    End Sub
End Class

Module UPT_Ctrl
    Public Const OFF_STATIC As Byte = 0
    Public Const ON_STATIC As Byte = 1
    Public Const PATT_MOVE1 As Byte = 2
    Public Const PATT_MOVE2 As Byte = 3
    Public Const PATT_MOVE3 As Byte = 4
    Public Const PATT_MOVE4 As Byte = 5
    Public Const PATT_KEEP As Byte = 9

    ' Color of LED Unit 
    Public Const UPT_RED As Byte = 10
    Public Const UPT_YEL As Byte = 11
    Public Const UPT_GRN As Byte = 12
    Public Const UPT_BLU As Byte = 13
    Public Const UPT_CLR As Byte = 14

    ' Pitch of Buzzer 
    Public Const BUZ_PITCH_OFF As Byte = 20
    Public Const BUZ_PITCH1 As Byte = 21
    Public Const BUZ_PITCH2 As Byte = 22
    Public Const BUZ_PITCH3 As Byte = 23
    Public Const BUZ_PITCH4 As Byte = 24
    Public Const BUZ_PITCH5 As Byte = 25
    Public Const BUZ_PITCH6 As Byte = 26
    Public Const BUZ_PITCH7 As Byte = 27
    Public Const BUZ_PITCH8 As Byte = 28
    Public Const BUZ_PITCH9 As Byte = 29
    Public Const BUZ_PITCH10 As Byte = 30
    Public Const BUZ_PITCH11 As Byte = 31
    Public Const BUZ_PITCH12 As Byte = 32
    Public Const BUZ_PITCH13 As Byte = 33
    Public Const BUZ_PITCH_DFLT As Byte = 59


    <DllImport("USB_PAT_Tower.dll", CharSet:=CharSet.Auto, CallingConvention:=CallingConvention.Cdecl)> _
    Function UPT_Open() _
      As Integer
    End Function

    <DllImport("USB_PAT_Tower.dll", CharSet:=CharSet.Auto, CallingConvention:=CallingConvention.Cdecl)> _
    Sub UPT_Close()
    End Sub

    <DllImport("USB_PAT_Tower.dll", CharSet:=CharSet.Auto, CallingConvention:=CallingConvention.Cdecl)> _
    Function UPT_SetLight(
       ByVal color As Byte, _
       ByVal led_state As Byte) _
      As Integer
    End Function

    <DllImport("USB_PAT_Tower.dll", CharSet:=CharSet.Auto, CallingConvention:=CallingConvention.Cdecl)> _
    Function UPT_SetTower(
       ByVal red As Byte, _
       ByVal yel As Byte, _
       ByVal grn As Byte, _
       ByVal blu As Byte, _
       ByVal clr As Byte) _
      As Integer
    End Function

    <DllImport("USB_PAT_Tower.dll", CharSet:=CharSet.Auto, CallingConvention:=CallingConvention.Cdecl)> _
    Function UPT_SetBuz(
       ByVal buz_state As Byte, _
       ByVal limit As Byte) _
      As Integer
    End Function

    <DllImport("USB_PAT_Tower.dll", CharSet:=CharSet.Auto, CallingConvention:=CallingConvention.Cdecl)> _
    Function UPT_SetBuzEx(
       ByVal buz_state As Byte, _
       ByVal limit As Byte, _
       ByVal pitch1 As Byte, _
       ByVal pitch2 As Byte) _
      As Integer
    End Function

    <DllImport("USB_PAT_Tower.dll", CharSet:=CharSet.Auto, CallingConvention:=CallingConvention.Cdecl)> _
    Function UPT_Reset() _
      As Integer
    End Function

    <DllImport("USB_PAT_Tower.dll", CharSet:=CharSet.Auto, CallingConvention:=CallingConvention.Cdecl)> _
    Function UPT_GetFirmVer() _
      As UShort
    End Function

    <DllImport("USB_PAT_Tower.dll", CharSet:=CharSet.Auto, CallingConvention:=CallingConvention.Cdecl)> _
    Function UPT_GetDllVer() _
      As UShort
    End Function

End Module
